From 0841930d34460e531d6397c34513b1fbb43c8383 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 20 2020 03:38:28 +0000
Subject: [PATCH 294/2232] Share one Namespace type between gen and macro


---

diff --git a/gen/mod.rs b/gen/mod.rs
index 523ba1d..998cd14 100644
--- a/gen/mod.rs
+++ b/gen/mod.rs
@@ -3,12 +3,11 @@
 
 mod error;
 pub(super) mod include;
-mod namespace;
 pub(super) mod out;
 mod write;
 
 use self::error::format_err;
-use self::namespace::Namespace;
+use crate::syntax::namespace::Namespace;
 use crate::syntax::{self, check, ident, Types};
 use quote::quote;
 use std::fs;
diff --git a/gen/out.rs b/gen/out.rs
index 35f2cd7..08bf85f 100644
--- a/gen/out.rs
+++ b/gen/out.rs
@@ -1,5 +1,5 @@
 use crate::gen::include::Includes;
-use crate::gen::namespace::Namespace;
+use crate::syntax::namespace::Namespace;
 use std::cell::RefCell;
 use std::fmt::{self, Arguments, Write};
 
diff --git a/gen/write.rs b/gen/write.rs
index 7a57111..28a2d3b 100644
--- a/gen/write.rs
+++ b/gen/write.rs
@@ -1,7 +1,7 @@
-use crate::gen::namespace::Namespace;
 use crate::gen::out::OutFile;
 use crate::gen::{include, Opt};
 use crate::syntax::atom::Atom::{self, *};
+use crate::syntax::namespace::Namespace;
 use crate::syntax::{Api, ExternFn, ExternType, Receiver, Signature, Struct, Type, Types, Var};
 use proc_macro2::Ident;
 use std::collections::HashMap;
diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index ac39e4e..373bfee 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -1,5 +1,5 @@
-use crate::namespace::Namespace;
 use crate::syntax::atom::Atom::{self, *};
+use crate::syntax::namespace::Namespace;
 use crate::syntax::{self, check, Api, ExternFn, ExternType, Signature, Struct, Type, Types};
 use proc_macro2::{Ident, Span, TokenStream};
 use quote::{format_ident, quote, quote_spanned};
diff --git a/macro/src/lib.rs b/macro/src/lib.rs
index 59433c1..49c4f42 100644
--- a/macro/src/lib.rs
+++ b/macro/src/lib.rs
@@ -13,7 +13,7 @@ mod expand;
 mod namespace;
 mod syntax;
 
-use crate::namespace::Namespace;
+use crate::syntax::namespace::Namespace;
 use proc_macro::TokenStream;
 use syn::{parse_macro_input, ItemMod};
 
diff --git a/macro/src/namespace.rs b/macro/src/namespace.rs
index d2b3e1c..2d14aa2 100644
--- a/macro/src/namespace.rs
+++ b/macro/src/namespace.rs
@@ -1,4 +1,5 @@
 use crate::syntax::ident;
+use crate::syntax::namespace::Namespace;
 use quote::IdentFragment;
 use std::fmt::{self, Display};
 use syn::parse::{Parse, ParseStream, Result};
@@ -8,10 +9,6 @@ mod kw {
     syn::custom_keyword!(namespace);
 }
 
-pub struct Namespace {
-    segments: Vec<String>,
-}
-
 impl Parse for Namespace {
     fn parse(input: ParseStream) -> Result<Self> {
         let mut segments = Vec::new();
@@ -25,17 +22,7 @@ impl Parse for Namespace {
             }
             input.parse::<Option<Token![,]>>()?;
         }
-        Ok(Namespace { segments })
-    }
-}
-
-impl Display for Namespace {
-    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
-        for segment in &self.segments {
-            f.write_str(segment)?;
-            f.write_str("$")?;
-        }
-        Ok(())
+        Ok(Namespace::new(segments))
     }
 }
 
diff --git a/syntax/mod.rs b/syntax/mod.rs
index 4eaf81e..21ff447 100644
--- a/syntax/mod.rs
+++ b/syntax/mod.rs
@@ -7,6 +7,7 @@ mod doc;
 pub mod error;
 pub mod ident;
 mod impls;
+pub mod namespace;
 mod parse;
 pub mod set;
 mod tokens;
diff --git a/syntax/namespace.rs b/syntax/namespace.rs
new file mode 100644
index 0000000..557e331
--- /dev/null
+++ b/syntax/namespace.rs
@@ -0,0 +1,35 @@
+use std::fmt::{self, Display};
+use std::slice::Iter;
+
+#[derive(Clone)]
+pub struct Namespace {
+    segments: Vec<String>,
+}
+
+impl Namespace {
+    pub fn new(segments: Vec<String>) -> Self {
+        Namespace { segments }
+    }
+
+    pub fn iter(&self) -> Iter<String> {
+        self.segments.iter()
+    }
+}
+
+impl Display for Namespace {
+    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
+        for segment in self {
+            f.write_str(segment)?;
+            f.write_str("$")?;
+        }
+        Ok(())
+    }
+}
+
+impl<'a> IntoIterator for &'a Namespace {
+    type Item = &'a String;
+    type IntoIter = Iter<'a, String>;
+    fn into_iter(self) -> Self::IntoIter {
+        self.iter()
+    }
+}

